http://poj.org/problem?id=3126
Prime Path
Time Limit: 1000MS |
|
Memory Limit: 65536K |
Total Submissions: 14460 |
|
Accepted: 8159 |
Description
The ministers of the cabinet were quite upset by the message from the Chief of Security stating that they would all have to change the four-digit room numbers on their offices.
— It is a matter of security to change such things every now and then, to keep the enemy in the dark.
— But look, I have chosen my number 1033 for good reasons. I am the Prime minister, you know!
— I know, so therefore your new number 8179 is also a prime. You will just have to paste four new digits over the four old ones on your office door.
— No, it’s not that simple. Suppose that I change the first digit to an 8, then the number will read 8033 which is not a prime!
— I see, being the prime minister you cannot stand having a non-prime number on your door even for a few seconds.
— Correct! So I must invent a scheme for going from 1033 to 8179 by a path of prime numbers where only one digit is changed from one prime to the next prime.
Now, the minister of finance, who had been eavesdropping, intervened.
— No unnecessary expenditure, please! I happen to know that the price of a digit is one pound.
— Hmm, in that case I need a computer program to minimize the cost. You don't know some very cheap software gurus, do you?
— In fact, I do. You see, there is this programming contest going on... Help the prime minister to find the cheapest prime path between any two given four-digit primes! The first digit must be nonzero, of course. Here is a solution in the case above.
1033
1733
3733
3739
3779
8779
8179
The cost of this solution is 6 pounds. Note that the digit 1 which got pasted over in step 2 can not be reused in the last step – a new 1 must be purchased.
Input
One line with a positive number: the number of test cases (at most 100). Then for each test case, one line with two numbers separated by a blank. Both numbers are four-digit primes (without leading zeros).
Output
One line for each case, either with a number stating the minimal cost or containing the word Impossible.
Sample Input
3
1033 8179
1373 8017
1033 1033
Sample Output
6
7
0
题意: 给两个质数,将第一个质数变为第二个质数,过程中,每变化一次,只能变化其中一位数,而且每次变化得到的必须是质数
1033→1733→3733→3739→3779→8779→8179;;;;
简单的bfs下面给出代码
#include <iostream>
#include <string.h>
#include <queue>
#include <math.h>
using namespace std;
bool is_prime[10010];
int tot;
bool f[10005];
int d[10005];
int dx[4]= {1,10,100,1000};
void get_prime()
{
int i,j;
for(i=1000; i<=10000; i++)
{
for(j=2; j<=(int)sqrt((double)i); j++)///||j*j<=i
{
if(i%j == 0)
{
is_prime[i]=false;
break;
}
is_prime[i] = true;
}
}
}
int jianwei(int m,int i)
{
int k;
if(i==0)
return m/10*10;
if(i==1)
{
k=m%10;
return m/100*100+k;
}
if(i==2)
{
k=m%100;
return m/1000*1000+k;
}
if(i==3)
return m%1000;
}
///bfd
int bfs(int m,int n)
{
queue<int>q;
q.push(m);
memset(f,0,sizeof(f));
f[m]=1;
d[m]=0;
while(q.size())
{
int p=q.front();
q.pop();
f[p]=1;
for(int i=0; i<4; i++)
{
for(int j=0; j<10; j++)
{
int low=jianwei(p,i);
int k=dx[i]*j+low;///遍历0——9,将该位数字遍历一遍,
if(!f[k]&&is_prime[k])///该数没有用过,并且是质数
{
q.push(k);///将该数加入队列
d[k]=d[p]+1;///距离 +1
f[k]=1;///标记为已经使用过
}
if(k==n)
break;
}
}
}
return d[n];
}
int main()
{
get_prime();
int m,n,ans,t;
cin>>t;
while(t--)
{
cin>>m>>n;
ans= bfs(m,n);
cout<<ans<<endl;
}
return 0;
}